local texture
local texture1
local texture2
local texture3
local size=16
local padding=1
local paddedSize = size+padding*2
local batch
local batchImg

local function genTexture(color, size, padding)
  local img = love.image.newImageData(paddedSize, paddedSize)
  for x=0, img:getWidth()-1 do
    for y=0, img:getHeight()-1 do
      if x <= padding or y <= padding or x >= padding+size-1 or y >= padding+size-1 then
        img:setPixel(x,y, unpack(color))
      end      
    end
  end
  return img
end

function love.load()  
  texture = genTexture({255,0,0,255}, size,padding)
  texture1 = genTexture({0,255,0,255}, size,padding)
  batchImg = love.image.newImageData(2 * paddedSize,paddedSize)
  batchImg:paste(texture, 0,0, 0,0, paddedSize,paddedSize)
  batchImg:paste(texture1, paddedSize,0, 0,0, paddedSize,paddedSize)
  batchImg = love.graphics.newImage(batchImg)
  batch = love.graphics.newSpriteBatch(batchImg)
  
  batch:add(love.graphics.newQuad(padding,padding,size,size,batchImg:getWidth(),batchImg:getHeight()),0,0)
  batch:add(love.graphics.newQuad(paddedSize+padding, padding,size,size,batchImg:getWidth(),batchImg:getHeight()),size,0)
  
end

function love.draw()
  local yStep = size+padding+8
  
  for i= 0, 10 do
    local x = 0.1 * i
    local y = yStep*(i+1)
    love.graphics.draw(batch,x,y)
  end
  love.graphics.draw(batchImg, 500,500)
end